package com.example.groracle.DAL.DAO;

import java.util.List;

import org.hibernate.SQLQuery;
import org.hibernate.Session;

import com.example.groracle.DAL.SessionFactoryUtil;
import com.example.groracle.Entity.Agregated.GrokLine;
/**
 * Class implementing operations on top of GrokLine object
 * @author tdosek
 * @version 1.1
 */
public class GrokLineDAO {
    private Session ss = null;
    /**
     * Constructor of the class - only thing to do here is to open session to DB
     */
    public GrokLineDAO(){
	ss = SessionFactoryUtil.getSessionFactory().openSession();
    }
    /**
     * Method returning all lines that are in blacklist and filters them according to confirmed flag
     * @param confirmed filter flag
     * @return List of patterns and count of lines per pattern
     */
    public List<GrokLine> getAllLines(Boolean confirmed){
	ss.beginTransaction();
	String sQuery = "SELECT input.pattern,count(*) FROM input LEFT JOIN pattern_blacklist ON "
		+ "input.pattern = pattern_blacklist.pattern WHERE pattern_blacklist.pattern IS NOT NULL "
		+ "AND pattern_blacklist.confirmed = '"+confirmed+"'"
		+ "GROUP BY input.pattern ORDER BY count DESC";
	SQLQuery query = ss.createSQLQuery(sQuery).addEntity(GrokLine.class);
	List<GrokLine> result = query.list();
	ss.getTransaction().commit();
	return result;
    }
    /**
     * Method for closing the session - it flushes database connection
     */
    public void closeSession(){
	ss.flush();
	ss.clear();
	ss.close();
    }

}
