package com.example.groracle.DAL.DAO;
import java.util.List;

import org.hibernate.SQLQuery;
import org.hibernate.Session;

import com.example.groracle.DAL.SessionFactoryUtil;
import com.example.groracle.Entity.Agregated.StatLinePerHost;
/**
 * Class implementing operations on top of StatLinePerDate object
 * @author tdosek
 * @version 1.1
 */
public class StatLinePerHostDAO {
    private Session ss = null;
    /**
     * Constructor of the class - only thing to do here is to open session to DB
     */
    public StatLinePerHostDAO(){
	ss = SessionFactoryUtil.getSessionFactory().openSession();
    }
    /**
     * Method returning statistic of lines per host
     * @return List of hosts with matching count of lines
     */
    public List<StatLinePerHost> getStat(){
	ss.beginTransaction();
	String sQuery = "SELECT host,count(*) FROM input GROUP BY host";
	SQLQuery query = ss.createSQLQuery(sQuery).addEntity(StatLinePerHost.class);
	List<StatLinePerHost> result = query.list();
	ss.getTransaction().commit();
	return result;
    }
    /**
     * Method for closing the session - it flushes database connection
     */
    public void closeSession(){
	ss.flush();
	ss.clear();
	ss.close();
    }
}
