package com.example.groracle.DAL;

import org.hibernate.SessionFactory;
import org.hibernate.cfg.Configuration;
import org.hibernate.service.ServiceRegistry;
import org.hibernate.service.ServiceRegistryBuilder;

import com.example.groracle.Entity.Group;
import com.example.groracle.Entity.Host;
import com.example.groracle.Entity.Input;
import com.example.groracle.Entity.PatternBlacklist;
import com.example.groracle.Entity.Right;
import com.example.groracle.Entity.Role;
import com.example.groracle.Entity.User;
import com.example.groracle.Entity.Agregated.GrokLine;
import com.example.groracle.Entity.Agregated.StatLinePerHost;
import com.example.groracle.Entity.Agregated.StatLinePerPattern;
import com.example.groracle.Entity.Agregated.StatLinePerDate;
/**
 * Class providing hibernate session factory to all DAOs
 * @author tdosek
 * @version 1.1
 */
public class SessionFactoryUtil {
    
    private static final SessionFactory sessionFactory = buildSessionFactory();
    /**
     * Method creating session factory to all DAOs 
     * @return Session factory instance
     */
    private static SessionFactory buildSessionFactory() {
        try {
            // Create the SessionFactory from hibernate.cfg.xml
            Configuration newConfig = new Configuration();
            newConfig.configure();
            newConfig.addAnnotatedClass(Group.class);
            newConfig.addAnnotatedClass(Host.class);
            newConfig.addAnnotatedClass(Input.class);
            newConfig.addAnnotatedClass(PatternBlacklist.class);
            newConfig.addAnnotatedClass(Right.class);
            newConfig.addAnnotatedClass(Role.class);
            newConfig.addAnnotatedClass(User.class);
            newConfig.addAnnotatedClass(GrokLine.class);
            newConfig.addAnnotatedClass(StatLinePerHost.class);
            newConfig.addAnnotatedClass(StatLinePerDate.class);
            newConfig.addAnnotatedClass(StatLinePerPattern.class);
            ServiceRegistry sr = new ServiceRegistryBuilder().applySettings(newConfig.getProperties()).buildServiceRegistry();
            return newConfig.buildSessionFactory(sr);
        }
        catch (Throwable ex) {
            System.err.println("Initial SessionFactory creation failed." + ex);
            throw new ExceptionInInitializerError(ex);
        }
    }
    /**
     * Method providing session factory to all DAOs 
     * @return Session factory instance
     */
    public static SessionFactory getSessionFactory() {
        return sessionFactory;
    }

}
